@extends('layouts.master')

@section('navigation')
    @if(Auth::user()->role==1)
        @include('local.managers.admins._navigation')
    @elseif(Auth::user()->role==2)
        @include('local.managers.sCoords._navigation')
    @elseif(Auth::user()->role==3)
        @include('local.managers.pCoords._navigation')
    @endif
@stop

@section('main')
    <div class="row">
        <div class="col-md-12">
            <p>Click the links below to see reports for Schools with assessed courses during the following semester(s):</p>
            <ul>
                @foreach (Session::get('semesters_info') as $semester_info)
                    <li>{{ $semester_info }}</li>
                @endforeach
            </ul>
            <p>Due to the large amount of information in these reports, please allow them to load a few seconds.</p>

            <ol id="table-of-contents" class="upper-roman">
            @foreach($outcomes as $outcome)
                <li>
                    <a href="{{ URL::action('OutcomesController@assessmentReport', array($outcome->id))}}">
                        {{ $outcome->name }}
                    </a>
                </li>
            @endforeach
            </ol>
        </div>
    </div>
@stop
