@extends('layouts.master')

@section('navigation')
    @if(Auth::user()->role==1)
        @include('local.managers.admins._navigation')
    @elseif(Auth::user()->role==2)
        @include('local.managers.sCoords._navigation')
    @elseif(Auth::user()->role==3)
        @include('local.managers.pCoords._navigation')
    @endif
@stop

@section('main')

    <div class="row">
        <div class="col-md-10">
            <h3>Courses</h3>
        </div>
        <div class="col-md-2">
            <a href="{{ $report_link }}" class="btn btn-lg btn-default" role="button">Report</a>
        </div>
    </div>
    <div class="row">
        @foreach($courses as $course)
            <div class="col-md-2">
{{--                TODO: Add href --}}
                <a href="{{ URL::action('CoursesController@newShow', ['id' => $course->id]) }}" style="text-decoration: none">
                    <div class="panel panel-default" style="height: 10rem">
                        <div class="panel-heading">
                            <h5 class="panel-title">{{ $course->code }}</h5>
                        </div>
                        <div class="panel-body">
                            <h6>{{ $course->name }}</h6>
                        </div>
                    </div>
                </a>
            </div>
        @endforeach
    </div>
    <div class="row">
        <div class="col-md-12">
            <h3>Activities</h3>
        </div>
    </div>
    <div class="row">
        @foreach($activities as $activity)
            <div class="col-md-2">
                {{--                TODO: Add href --}}
                <a href="" style="text-decoration: none">
                    <div class="panel panel-default" style="height: 10rem">
                        <div class="panel-heading">
                            <h5 class="panel-title">{{ $activity->name }}</h5>
                        </div>
                        <div class="panel-body">
                            <h6>{{ $activity->description }}</h6>
                        </div>
                    </div>
                </a>
            </div>
        @endforeach
    </div>
@stop

@section('included-js')
    @include('global._datatables_js')
@stop

@section('javascript')

    // ------------------------------------------------------------------------
    // Page Load
    // ------------------------------------------------------------------------

    // ------------------------------------------------------------------------
    // Events
    // ------------------------------------------------------------------------



    // ------------------------------------------------------------------------
    // Functions
    // ------------------------------------------------------------------------

@stop
