@extends('layouts.master')

@section('navigation')
    @if(Auth::user()->role==1)
        @include('local.managers.admins._navigation')
    @elseif(Auth::user()->role==2)
        @include('local.managers.sCoords._navigation')
    @elseif(Auth::user()->role==3)
        @include('local.managers.pCoords._navigation')
    @endif
@stop

@section('main')
    <div class="row">
        <div class="col-md-12">
            <p>Click the links below to see reports for your program's assessed courses during the following semester(s):</p>
            <ul>
                @foreach (Session::get('semesters_info') as $semester_info)
                    <li>{{ $semester_info }}</li>
                @endforeach
            </ul>
            <p>Due to the large amount of information in these reports, please allow them to load a few seconds.</p>

            <table class="table">
                <thead>
                    <tr>
                        <td></td>
                        @foreach($programs as $program)
                            <td><span class="active"></span> {{ $program->name }}</td>
                        @endforeach
                    </tr>
                </thead>
                @foreach($outcomes as $outcome)
                    <tr>
                        <td>
                            {{ $outcome->name }}
                        </td>

                        @foreach($programs as $program)
                            <td>
                                <a href="{{ URL::action('OutcomesController@programAssessmentReport', array($outcome->id, $program->id))}}">
                                    <span class="glyphicon glyphicon-eye-open icon-btn"></span> View
                                </a>
                            </td>
                        @endforeach

                    </tr>
                @endforeach
            </table>
        </div>
    </div>
@stop
