@extends('layouts.master')

@section('navigation')
    @include('local.managers.pCoords._navigation')
@stop

@section('main')

    <!-- Nav tabs -->
    <ul id="programTabs" class="nav nav-tabs" role="tablist">
        @foreach($programs_array as $index => $program_item)
            <li role="presentation" <?php if($index==0){ echo 'class="active"';}?> >
                <a href="#programs{{ $index }}" aria-controls="program" role="tab">{{ $program_item['program']->name }}</a>
            </li>
        @endforeach
    </ul>

    <!-- Tab panes -->
    <div class="tab-content">
        @foreach($programs_array as $index => $program_item)
            <div role="tabpanel" class="tab-pane <?php if($index==0){ echo 'active';}?>" id="programs{{ $index }}">

                <br>
                <br>

                <a href="{{ action('ProgramsController@print_program', array($program_item['program']->id)); }}" class="btn btn-primary pull-right" alt="print"><span class="glyphicon glyphicon-print"></span></a>
                <br>
                <br>


                <div class="row">
                    <div class="col-md-12 graph" id="graph{{ $index }}"></div>
                </div>

                <!-- =================== sub tabs =================== -->
                <div>
                    <!-- Sub nav tabs -->
                    <ul id="programSubTabs{{ $index }}" class="nav nav-tabs" role="tablist">
                        <li role="presentation" class="active"><a href="#courses{{ $index }}" aria-controls="courses" role="tab">Courses</a></li>
                        <li role="presentation"><a href="#sections{{ $index }}" aria-controls="sections" role="tab">Sections</a></li>
                        <li role="presentation">
                            <a href="#contact{{ $index }}" aria-controls="contact" role="tab">Contact Information</a>
                        </li>
                    </ul>

                    <!-- Sub tab panes -->
                    <div class="tab-content">
                        <div role="tabpanel" class="tab-pane active" id="courses{{ $index }}">
                            <div class="row">
                                <div class="col-md-12">
                                    <h3>Courses in this program</h3>
                                    <p>Note that some courses may have assessed activities but unpublished results. Unplublished results are <strong>not considered</strong>. Check the Sections tab for a breakdown.</p>
                                    @if($program_item['program_courses']->count()>0)
                                        <table class="table table-striped table-condensed datatable">
                                            <thead>
                                                <tr>
                                                    <th>Identifier</th>
                                                    <th>Name</th>
                                                    <th>Program</th>
                                                    <th>Assessed and Published</th>
                                                </tr>
                                            </thead>
                                            <tfoot>
                                                <tr class="column-search">
                                                    <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                    <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                    <th><select class="column-search-select form-control"><option value=""></option></select></th>
                                                    <th><select class="column-search-select form-control"><option value=""></option></select></th>
                                                </tr>
                                            </tfoot>
                                            <tbody>
                                                @foreach($program_item['grouped_courses'] as $grouped_course)
                                                    <tr>
                                                        <td class="col-md-1">{{ HTML::linkAction('CoursesController@showGrouped', $grouped_course->code.$grouped_course->number.' ('.$grouped_course->semester->code.')', array($grouped_course->code, $grouped_course->number, $grouped_course->semester->code)) }}</td>
                                                        <td class="col-md-3">{{{ $grouped_course->name}}}</td>
                                                        <td class="col-md-3">{{{ $grouped_course->program->name }}}</td>
                                                        <td class="col-md-2">
                                                            @if($grouped_course->outcomes_attempted!=NULL)
                                                                Yes
                                                            @else
                                                                No
                                                            @endif
                                                        </td>
                                                    </tr>
                                                @endforeach
                                            </tbody>
                                        </table>
                                    @else
                                        <p class="lead"> No courses assigned.</p>
                                    @endif
                                </div>
                            </div>
                        </div>

                        <div role="tabpanel" class="tab-pane" id="sections{{ $index }}">
                            <div class="row">
                                <div class="col-md-12">
                                    <h3>Sections in this program</h3>
                                    @if($program_item['program_courses']->count()>0)
                                        <p class="lead"> {{{ $program_item['assessed_courses_count'] }}} out of {{{ $program_item['program_courses']->count() }}} section(s) doing Assessment ({{{ round($program_item['assessed_courses_count']/$program_item['program_courses']->count()*100, 2) }}}%)</p>
                                        <p>Note that some courses may have assessed activities but unpublished results. Unplublished results are <strong>not considered</strong>.</p>

                                        <table class="table table-striped table-condensed datatable">
                                            <thead>
                                                <tr>
                                                    <th>Identifier</th>
                                                    <th>Name</th>
                                                    <th>Professor</th>
                                                    <th>Assessed Activities</th>
                                                    <th>Published Results</th>
                                                </tr>
                                            </thead>
                                            <tfoot>
                                                <tr class="column-search">
                                                    <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                    <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                    <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                    <th><select class="column-search-select form-control"><option value=""></option></select></th>
                                                    <th><select class="column-search-select form-control"><option value=""></option></select></th>
                                                </tr>
                                            </tfoot>
                                            <tbody>
                                                @foreach($program_item['program_courses'] as $course)
                                                <tr>
                                                    <td>{{ HTML::linkAction('CoursesController@showLimited', $course->code.$course->number.'-'.$course->section.' ('.$course->semester->code.')', array('id'=>$course->id)) }}</td>
                                                    <td>{{{ $course->name}}}</td>
                                                    <td>{{{ $course->user->surnames }}}, {{{ $course->user->first_name }}}</td>
                                                    <td>
                                                        @if(count($course->assessedActivities))
                                                            Yes
                                                        @else
                                                            No
                                                        @endif
                                                    </td>
                                                    <td>
                                                        @if(count($course->publishedActivities))
                                                            Yes
                                                        @else
                                                            No
                                                        @endif
                                                    </td>
                                                </tr>
                                                @endforeach
                                            </tbody>
                                        </table>
                                    @else
                                        <p class="lead"> No sections assigned.</p>
                                    @endif
                                </div>
                            </div>
                        </div>
                        <div role="tabpanel" class="tab-pane" id="contact{{ $index }}">
                            <div class="row">
                                <div class="col-md-12">
                                    <h3>Contact information</h3>
                                    <table class="table table-striped datatable">
                                        <thead>
                                            <tr>
                                                <th>Name</th>
                                                <th>Role</th>
                                                <th>Program(s)</th>
                                                <th>Email</th>
                                                <th>Office Phone</th>
                                                <th>Cell Phone</th>
                                            </tr>
                                        </thead>
                                        <tfoot>
                                            <tr class="column-search">
                                                <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                <th><select class="column-search-select form-control"><option value=""></option></select></th>
                                                <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                                <th><input class="column-search-bar form-control" type="text" placeholder="Search"/></th>
                                            </tr>
                                        </tfoot>
                                        <tbody>
                                            @foreach($programs_contact[$index] as $user)
                                                <tr>
                                                    <td>{{ $user->surnames }}, {{ $user->first_name }}</td>

                                                    @if($user->role == 1)
                                                        <td>Administrator</td>
                                                        <td>All</td>
                                                    @elseif($user->role == 2)
                                                        <td>School Coordinator</td>
                                                        <td>All in {{ $program_item['program']->school->name }}</td>
                                                    @elseif($user->role == 3)
                                                        <td>Program Coordinator</td>
                                                        <td>
                                                            @foreach ($user->programs as $program)
                                                                <p>{{ $program->name }}</p>
                                                            @endforeach
                                                        </td>
                                                    @else
                                                        <td>Professor</td>
                                                        <td>
                                                            @foreach ($user->programs as $program)
                                                                <p>{{ $program->name }}</p>
                                                            @endforeach
                                                        </td>
                                                    @endif

                                                    <td>
                                                        <a href="mailto:{{ $user->email }}">{{ $user->email }}</a>
                                                    </td>
                                                    <td>
                                                        @if($user->office_phone)
                                                            {{{ $user->office_phone }}}

                                                            @if($user->office_extension)
                                                                <span>ext.</span> {{{ $user->office_extension }}}
                                                            @endif
                                                        @else
                                                            Not set
                                                        @endif
                                                    </td>
                                                    <td>
                                                        @if($user->cell_phone)
                                                            {{{ $user->cell_phone }}}
                                                        @else
                                                            Not set
                                                        @endif
                                                    </td>
                                                </tr>
                                            @endforeach
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- =================== end sub tabs =================== -->
            </div>
        @endforeach
    </div>


@stop

@section('included-js')

<!-- HighCharts -->
<script src="{{ asset('vendor/highcharts/highcharts.js') }}"></script>
<!--script src="http://code.highcharts.com/modules/exporting.js"></script -->

<!-- Datatables -->
@include('global._datatables_js')

@stop

@section('javascript')

// Create an function that responds to click of program tabs
@foreach($programs_array as $index => $program_item)

    $('#programTabs a').click(function (e) {

        e.preventDefault()
        $(this).tab('show');

        $('#programSubTabs{{$index}} a').click(function (e) {
            e.preventDefault()
            $(this).tab('show');
        });

        $('#graph{{$index}}').highcharts({
            chart: {
                type: 'bar'
            },
            title: {
                text: 'Performance by Learning Outcome Criteria in {{ $program_item['program']->name }} Program'
            },
            legend: {
                        reversed: true,
                    },
            xAxis: {
                categories: [
                    @foreach($outcomes as $outcome)
                        "{{{ $outcome->name }}}",
                    @endforeach
                ],
                labels: {
                    style: {
                        fontSize:'11px'
                    },
                    step:1,
                    useHTML:true,
                    formatter: function() {
                        return '<div style="width:200px; word-break:break; text-overflow:ellipsis; overflow:hidden;">'+this.value+'</div>';
                    },
                }
            },
            yAxis: {
                min: 0,
                max: 100,
                title: {
                    text: 'Percentage'
                }
            },
            tooltip: {
                headerFormat: '<span style="font-size:10px">{point.key}</span><table>',
                pointFormat: '<tr><td style="color:{series.color};padding:0">{series.name}: </td>' +
                    '<td style="padding:0"><b>{point.y:.2f}</b></td></tr>',
                footerFormat: '</table>',
                shared: true,
                useHTML: true
            },
            plotOptions: {
                bar: {
                    //grouping: false,
                    shadow: false,
                    borderWidth: 0,
                },
                series: {
                pointPadding: 0,
                groupPadding: 0.075
                },
            },
            series: [{
                name: 'Expected Value',
                color: '#555555',
                dataLabels: {
                    enabled: true,
                    fontSize: 8,
                    color: '#fff',
                    align: 'right',
                    format: '{y:.1f}%',
                    style: {
                        //fontWeight: 'bold'
                    },
                    y:-1
                },
                data: [
                    @foreach($outcomes as $index => $outcome)
                        @if(
                            is_array($program_item['outcomes_attempted'])
                            && array_key_exists($outcome->id, $program_item['outcomes_attempted'])
                            && $program_item['outcomes_attempted'][$outcome->id]!=0)
                            {{{ $outcome->expected_outcome }}},
                        @else
                            0,
                        @endif
                    @endforeach
                ]

            },{
                name: 'Obtained Value',
                color: '#e70033',
                dataLabels: {
                    enabled: true,
                    fontSize: 8,
                    color: '#fff',
                    align: 'right',
                    format: '{y:.1f}%',
                    style: {
                        //fontWeight: 'bold'
                    },
                    y:-1
                },
                data:[
                    @foreach($outcomes as $index => $outcome)
                        @if(
                            is_array($program_item['outcomes_attempted'])
                            && array_key_exists($outcome->id, $program_item['outcomes_attempted'])
                            && $program_item['outcomes_attempted'][$outcome->id]!=0)
                            {{{ ($program_item['outcomes_achieved'][$outcome->id]/$program_item['outcomes_attempted'][$outcome->id])*100 }}},
                        @else
                            0,
                        @endif
                    @endforeach
                ]
            }]
        });

    });
@endforeach

// Trigger click on first tab so it loads automatically
$( '#programTabs a:eq(0)').trigger('click');

// Include dummy graph for outcomes
@include('global.dummy-outcomes')

@stop
