@extends('layouts.master')

@section('navigation')
@include('local.managers.sCoords._navigation')
@stop
@section('main')

<div class="row">
    <div class="col-md-6">
        <!-- Form to add a new criterion -->
        <div class="panel panel-default panel-button">
            <div class="panel-heading">
                Create
            </div>
            <div class="panel-body">
                {{ Form::open(array('action' => 'CriteriaController@create')) }}
                <div id='outcomeGroup' data-value='1'>
                    <div class="form-group col-md-11">
                        <label>Associated Outcomes</label>

                        {{ Form::select('outcome[]', $outcomes, reset($outcomes),  ['class'=>'form-control selectpicker', 'id' =>'outcome0', 'onchange'=>'fetchObjectiveForSelect("outcomeGroup", "objectiveGroup")']) }}

                    </div>
                </div>
                <input type='hidden' name='counterOutcome' id='counterOutcome' value=1>
                <button id='button-add-outcome' class='btn btn-md btn-secondary' onclick='addOutcomeTest()'>
                    <span class='glyphicon glyphicon-plus'>

                    </span>
                    Add another Outcome
                </button>
                <div id='objectiveGroup' data-value ="1">
                    <div class="form-group">
                        <label>Associated Objectives</label>
                        <select id="objective_0" name="objective[]" class="form-control selectpicker">
                        </select>

                    </div>
                </div>
                <input type='hidden' name='counterObjective' id='counterObjective' value=1>
                <button id='button-add-objective' class='btn btn-md btn-secondary' onclick='addObjectiveTest()'>
                    <span class='glyphicon glyphicon-plus'>

                    </span>
                    Add another Objective
                </button>

                <!-- Associated Program -->
                <div class="form-group">
                    {{ Form::label('program_id', 'Associated Program') }}<br>
                    <br>

                    @foreach ($programs as $program)

                    <input type="checkbox" id="{{ $program->name }}" name="program_id[]" value="{{$program->id}}">
                    <label for="{{ $program->name }}"> {{ $program->name }} [{{ $program->school->name }}]</label><br>
                    @endforeach

                </div>

                <div class="form-group">
                    {{ Form::label('name', 'Name') }}
                    {{ Form::text('name', '', array('class' => 'form-control')) }}
                </div>

                <div class="form-group">
                    {{ Form::label('subcriteria', 'Subcriteria') }}
                    <p class="help-block"><strong>Manually add</strong> bullets or numbering.</p>
                    {{ Form::textarea('subcriteria', '', array('class' => 'form-control', 'rows'=>3, 'aria-labelledby'=>'subcriteria')) }}
                </div>
                


                <div class="form-group">
                    {{ Form::label('copyright', 'Copyright') }}
                    {{ Form::textarea('copyright', '', array('class' => 'form-control', 'rows'=>2, 'placeholder'=>'(optional)', 'aria-labelledby'=>'copyright')) }}
                </div>

                <div class="form-group">
                    {{ Form::label('notes', 'Notes') }}
                    {{ Form::textarea('notes', '', array('class' => 'form-control', 'rows'=>2, 'placeholder'=>'(optional)', 'aria-labelledby'=>'notes')) }}
                </div>

                {{ Form::submit('Create', array('class' => 'btn btn-primary btn-block')) }}
                {{ Form::close() }}
            </div>
        </div>
    </div>

    <div class="col-md-6">
        <div class="panel panel-default panel-button">
            <div class="panel-heading">
                Edit
            </div>
            <div class="panel-body">
                {{ Form::open(array('action' => 'CriteriaController@update')) }}
                <button class="btn btn-md btn-secondary filterButton">
                    <span class="glyphicon glyphicon-plus">
                    </span>
                    Filters
                  </button>
                <div class="filterSection">
                <div class="form-group">
                    {{ Form::label('program_id2', 'Associated Program')}}
                    <select id='select-program' class="form-control selectpicker" onchange='fetchAllCriterion("select-program", "assoc_outcomes_fetch")'>
                        @foreach ($programs as $program)
                        <option value='{{$program->id}}' data-subtext="{{$program->code}}">{{$program->name}}</option>
                        @endforeach
                    </select>
                </div>
                <div class="form-group">
                    <label>Associated Outcome</label>
                    {{ Form::select('assoc_outcome_fetch', $outcomes, null, ['class'=>'form-control selectpicker', 'id'=>'assoc_outcomes_fetch', 'onchange'=>'fetchAllCriterion("select-program", "assoc_outcomes_fetch")']) }}

                </div>
                </div>

                <div class="form-group">
                    {{ Form::label('criterion_id', 'Criterion') }}
                    <select id="select-criterion" name="id" class="form-control selectpicker" onchange='fetchCriterionForEditing()'>
                        @foreach ($criteria as $criterion)
                        <option value="{{ $criterion->id }}" data-subtext="
                                        @if($criterion->program)
                                            &nbsp;&nbsp;&nbsp;[{{ $criterion->program->name }}]
                                        @endif
                                        ">
                            {{ $criterion->name }}



                        </option>
                        @endforeach
                    </select>
                </div>

                <!-- Associated Outcome -->
                <div id='assocOutcomeGroup' data-value='1'>
                    <div class="form-group">
                        <label>Associated Outcome</label>
                        {{ Form::select('assoc_outcome[]', $outcomes, null, ['class'=>'form-control selectpicker', 'id'=>'assoc_outcome_0', 'onchange'=>'fetchAssocObjective("assoc_outcome_0")']) }}

                    </div>
                </div>
                <button id='button-add-objective-assoc' class='btn btn-md btn-secondary' onclick='addAssocOutcome()'>
                    <span class='glyphicon glyphicon-plus'>

                    </span>
                    Add another Outcome
                </button>

                <div id='assoc_objectiveGroup' data-value='1'>
                    <div class="form-group">
                        <label>Associated Objectives</label>
                        <select id="assoc_objective_0" name="assoc_objective[]" class="form-control selectpicker">
                            <option value="0">No associated objectives</option>
                        </select>

                    </div>
                </div>
                <button id='button-add-outcome-assoc' class='btn btn-md btn-secondary' onclick='addAssocObjective()'>
                    <span class='glyphicon glyphicon-plus'>

                    </span>
                    Add another Objective
                </button>

                <!-- Associated Program -->
                <div class="form-group">

                    {{ Form::label('program_id2', 'Associated Program') }}<br><br>
                    @foreach ($programs as $program)

                    <input type="checkbox" id="assoc_program_id_{{ $program->id }}" name="program_id[]" value="{{$program->id}}">
                    <label for="assoc_program_id_{{ $program->id }}"> {{ $program->name }} <sub>[{{ $program->school->name }}]</sub></label><br>
                    @endforeach
                </div>


                <!-- Status -->
                <div class="form-group">
                    {{ Form::label('status', 'Status') }}
                    <span data-toggle="tooltip" data-placement="top" title="Use this option to deactivate or reactivate criteria. Inactive criteria will stay in the system, but will not be available to use in new rubrics." class="glyphicon glyphicon-question-sign"></span>

                    <select id="status" name="status" class="form-control">
                        <option value="1">Active</option>
                        <option value="0">Inactive</option>
                    </select>
                </div>



                <div class="form-group">
                    {{ Form::label('name', 'Name') }}
                    {{ Form::text('name', Input::old('name'), array('class' => 'form-control', 'id'=>'criterion_name')) }}
                </div>

                <div class="form-group">
                    {{ Form::label('subcriteria', 'Subcriteria') }}
                    <p class="help-block"><strong>Manually add</strong> bullets or numbering.</p>
                    {{ Form::textarea('subcriteria', '', array('class' => 'form-control', 'rows'=>3, 'id' => 'criterion_subcriteria')) }}
                </div>

                

                <div class="form-group">
                    {{ Form::label('copyright', 'Copyright Information') }}
                    {{ Form::textarea('copyright', Input::old('copyright'), array('class' => 'form-control', 'rows'=>2, 'id'=>'criterion_copyright', 'placeholder'=>'(optional)')) }}
                </div>

                <div class="form-group">
                    {{ Form::label('notes', 'Additional Notes') }}
                    {{ Form::textarea('notes', Input::old('notes'), array('class' => 'form-control', 'rows'=>2, 'id'=>'criterion_notes', 'placeholder'=>'(optional)')) }}
                </div>
                
                {{ Form::submit('Update', array('class' => 'btn btn-primary btn-block')) }}
                {{ Form::close() }}

                {{ Form::open(array('action' => 'CriteriaController@delete')) }}
	
                <input type='hidden' name='criterion_delete' id='deleteCriteria'>

                {{Form::submit("Delete", array('class'=> 'btn btn-primary btn-block', 'id'=>"DeleteButton"))}}


            </div>
        </div>
    </div>
</div>
<script>

    var selectOptions = document.getElementById('outcome0').innerHTML;

    var counter = 1;
    var counterObj = 1;
    var outcomeString = 'OutcomeGroup_';
   
    $('.filterSection').hide();
    $('.filterButton').on('click', function()
{
  var span = $(this).find('span');
  if(span.attr('class') == 'glyphicon glyphicon-plus'){
    span.attr('class','glyphicon glyphicon-minus');
  } else{
    span.attr('class','glyphicon glyphicon-plus');
  }
  $('.filterSection').toggle(533);
});

 
    //Add outcome Button
    function addOutcomeTest() {
        counter = parseInt($('#outcomeGroup').data("value"));
        var $select = $('<select/>', {
            'class': "selectpicker form-control",
            'name': "outcome[]",
            'data-live-search': 'true',
            'id': 'outcome' + counter.toString(),
            'onchange': 'fetchObjectiveForSelect("outcomeGroup", "objectiveGroup")'

        });
        var $div = $('<div/>', {
            'id': 'outcomeForm' + counter.toString(),
            'class': 'form-group col-md-11'
        });

        var $divForButton = $('<div/>', {
            'class': 'col-md-1',
            'id': 'close' + counter.toString()

        });
        var $button = $('<button/>', {
            'type': 'button',
            'class': 'btn btn-primary',
            'onclick': 'deleteLast("outcomeForm'+counter.toString()+'", "outcomeGroup", "close' + counter.toString() + '", "objectiveGroup")'
        });

        $button.append('X');
        $divForButton.append($button);

        $div.appendTo('#outcomeGroup')
        $select.append(selectOptions);

        $select.appendTo('#outcomeForm' + counter.toString()).selectpicker('refresh');
        
        $('#outcomeGroup').data("value", counter +1);
        fetchObjectiveForSelect('outcomeGroup', "objectiveGroup");
        
        $divForButton.appendTo('#outcomeGroup');

       


    }



    //Delete Outcome and OptGroup associated

    function deleteLast(outcomeForm, outcomeDiv, closeButton, objectiveGroup) {
        $div = document.getElementById(outcomeForm );
        $div.remove();
        $div = document.getElementById(closeButton);
        $div.remove();
        if(outcomeDiv =='outcomeGroup'){
        $('#' + outcomeDiv).data('value',parseInt($('#' + outcomeDiv).data('value')) - 1);
        fetchObjectiveForSelect(outcomeDiv, objectiveGroup);}
        





    }
    //Delete Objective
    function deleteObjective(objectiveForm, closeObj, objectiveGroup) {
        $div = document.getElementById(objectiveForm);
        $div.remove();
        $div = document.getElementById(closeObj);
        $div.remove();
        counter = parseInt($('#'+objectiveGroup).data("value"));
        $('#'+objectiveGroup).data("value", counter-1);


    }

    //Add objective when editing

    function addAssocObjective() {
        selectObj = document.getElementById('assoc_objective_0').innerHTML;
        assocObjectiveCounter = parseInt($('#assoc_objectiveGroup').data('value'));
        var $select = $('<select/>', {
            'class': "selectpicker form-control",
            'name': "assoc_objective[]",
            'data-live-search': 'true',
            'id': 'assoc_objective_' + assocObjectiveCounter.toString(),


        });
        var $div = $('<div/>', {
            'id': 'assoc_objectiveForm' + assocObjectiveCounter.toString(),
            'class': 'form-group col-md-11'
        });
        var $divForButton = $('<div/>', {
            'class': 'col-md-1',
            'id': 'assoc_closeObj' + assocObjectiveCounter.toString()

        });
        var $button = $('<button/>', {
            'type': 'button',
            'class': 'btn btn-primary',
            'onclick': 'deleteObjective("assoc_objectiveForm' + assocObjectiveCounter.toString() + '", "assoc_closeObj' + assocObjectiveCounter.toString() + ', assoc_objectiveGroup")'
        });

        $button.append('X');
        $divForButton.append($button);

        $div.appendTo('#assoc_objectiveGroup')
        $select.append(selectObj);

        $select.appendTo('#assoc_objectiveForm' + assocObjectiveCounter.toString()).selectpicker('refresh');
        $('#assoc_objectiveGroup').data("value", assocObjectiveCounter +1);

        $divForButton.appendTo('#assoc_objectiveGroup');

    }


    //Add objective when creating a criteria
    function addObjectiveTest() {
        selectObj = document.getElementById('objective_0').innerHTML;
        counter = $("#objectiveGroup").data('value');
       
        var $select = $('<select/>', {
            'class': "selectpicker form-control",
            'name': "objective[]",
            'data-live-search': 'true',
            'id': 'objective_' + counter.toString()

        });
        var $div = $('<div/>', {
            'id': 'objectiveForm' + counter.toString(),
            'class': 'form-group col-md-11'
        });
        var $divForButton = $('<div/>', {
            'class': 'col-md-1',
            'id': 'closeObj' + counter.toString()

        });
        var $button = $('<button/>', {
            'type': 'button',
            'class': 'btn btn-primary',
            'onclick': 'deleteObjective("objectiveForm' + counter.toString() + '", "closeObj' + counter.toString() + '","objectiveGroup")'
        });

        $button.append('X');
        $divForButton.append($button);

        $div.appendTo('#objectiveGroup')
        $select.append(selectObj);

        $select.appendTo('#objectiveForm' + counter.toString()).selectpicker('refresh');
        
        $divForButton.appendTo('#objectiveGroup');
        $('#objectiveGroup').data('value', counter +1);
    }

    //Create outcome for editing

    var assocOutcomeCounter = 0;


    function addAssocOutcome() {
        assocOutcomeCounter = parseInt($('#assocOutcomeGroup').data('value'));
        var $select = $('<select/>', {
            'class': "selectpicker form-control",
            'name': "assoc_outcome[]",
            'data-live-search': 'true',
            'id': 'assoc_outcome_' + assocOutcomeCounter.toString(),
            'onchange': 'fetchAssocObjective("assoc_outcome_' + assocOutcomeCounter.toString() + '")'

        });
        var $div = $('<div/>', {
            'id': 'assoc_outcomeForm' + assocOutcomeCounter.toString(),
            'class': 'form-group col-md-11'
        });

        var $divForButton = $('<div/>', {
            'class': 'col-md-1',
            'id': 'assoc_close' + assocOutcomeCounter.toString()

        });
        var $button = $('<button/>', {
            'type': 'button',
            'class': 'btn btn-primary',
            'onclick': 'deleteLast("assoc_outcomeForm' + assocOutcomeCounter.toString() + '", "assocOutcomeGroup", "assoc_close' + assocOutcomeCounter.toString() + '","assoc_objectiveGroup")'
        });

        $button.append('X');
        $divForButton.append($button);

        $div.appendTo('#assocOutcomeGroup')
        $select.append(selectOptions);

        $select.appendTo('#assoc_outcomeForm' + assocOutcomeCounter.toString()).selectpicker('refresh');
        
        assocOutcomeCounter += 1;
        $('#assocOutcomeGroup').data('value', assocOutcomeCounter);

        $divForButton.appendTo('#assocOutcomeGroup');




    }
    //Fetch associated objective for editing


    var assocObjectiveCounter = 1;

    function fetchAssocObjective(outcomeDiv, objectiveGroup) {
        var count = $('#'+outcomeDiv).data('value');
        var allOutcomes =[];

         $("#" + outcomeDiv + ' select').each(function() {
            allOutcomes.push( this.value);

        })
        var allObjectives = [];
        $("#" + objectiveGroup + ' select').each(function() {
            var temp = {
                id: this.id,
                value: this.value
            }
            allObjectives.push(temp);
        })


        $.post(
            "{{ URL::action('CriteriaController@fetchObjectivesForSelect') }}", {
                allOutcomes: allOutcomes
            },

            function(json) {

                optionName = '<option value ="0">Nothing Selected</option>';
                for(outcome in varArray.outcomes){
                    optionName += '<optgroup label="' + varArray.outcomes[outcome][0].name + '">';
                    var objectiveForOutcome = varArray.objectives;
                    var objectives = objectiveForOutcome[outcome];
                    for (objective in objectives) {
                

                        var obj= objectives[objective];
                        var option = '<option value ="' + obj.id + '">' +obj.text + '</option>';
                        optionName += (option);
                    }
                    optionName += '</optgroup>'
                }


                $('#assoc_objective_0').html(optionName);
                $('#assoc_objective_0').selectpicker('refresh');
                if($("#assoc_objective_0 option[value='"+allObjectives[0].value+"']").length>0){
                    $("#assoc_objective_0").val(allObjectives[0].value);
                    $('#assoc_objective_0').selectpicker('refresh');
                }

                for (var i = allObjectives.length - 1; i > 0; i--) {
                    deleteObjective('assoc_objectiveForm' + i.toString(), 'assoc_closeObj' + i.toString(), 'assoc_objectiveGroup');
                }
                for(var i=1; i<allObjectives.length; i++){
                    addAssocObjective();
                    $('#assoc_objective_'+i.toString()).selectpicker('refresh');
                    if($("#assoc_objective_"+i.toString()+" option[value='"+allObjectives[i].value+"']").length>0){
                    $("#assoc_objective_"+i.toString()).val(allObjectives[i].value);
                    $("#assoc_objective_"+i.toString()).selectpicker("refresh");
                    }
                }



            },
            'json'
        );
    }

    //Fetch objective at creating criteria
    counterForPost = 0;

    function fetchObjectiveForSelect(outcomeDiv, objectiveGroup) {
        var count = $("#" + outcomeDiv).data('value');
        var allOutcomes = [];
        $("#" + outcomeDiv + ' select').each(function() {
            allOutcomes.push( this.value);

        })
        var allObjectives = [];
        $("#" + objectiveGroup + ' select').each(function() {
            var temp = {
                id: this.id,
                value: this.value
            }
            allObjectives.push(temp);
        })

        $.post(
            "{{ URL::action('CriteriaController@fetchObjectivesForSelect') }}", {
                allOutcomes: allOutcomes
            },
            function(varArray) {
                counterOutcome =0;
                optionName = '<option value ="0">Nothing Selected</option>';
                for(outcome in varArray.outcomes){
                    optionName += '<optgroup label="' + varArray.outcomes[outcome][0].name + '"';
                    var objectiveForOutcome = varArray.objectives;
                    var objectives = objectiveForOutcome[outcome];
                    for (objective in varArray.objectives[outcome]) {
                

                        var obj= objectives[objective];
                        var option = '<option value ="' + obj.id + '">' +obj.text + '</option>';
                        optionName += (option);
                    }
                }
                

                

                $('#objective_0').html(optionName);
                $('#objective_0').selectpicker('refresh');
                if($("#objective_0 option[value='"+allObjectives[0].value+"']").length>0){
                    $("#objective_0").val(allObjectives[0].value);
                    $('#objective_0').selectpicker('refresh');
                }
                

                for (var i = allObjectives.length - 1; i > 0; i--) {
                    deleteObjective('objectiveForm' + i.toString(), 'closeObj' + i.toString(), 'objectiveGroup');
                }
                for(var i =1; i<allObjectives.length; i++){
                    addObjectiveTest();
                    $('#objective_'+i.toString()).selectpicker('refresh');
                    if($("#objective_"+i.toString()+" option[value='"+allObjectives[i].value+"']").length>0){
                    $("#objective_"+i.toString()).val(allObjectives[i].value);
                    $("#objective_"+i.toString()).selectpicker("refresh");
                }
                }

                




            },
            'json'
        );
    }

    //after post


    //For editing criterion
    function fetchAllCriterion(program, outcome) {
        var program_id_fetch = $('#' + program).find(':selected').val();
        var outcome_fetch = $('#' + outcome).find(':selected').val();
        $.post(
            "{{URL::action('CriteriaController@fetchAllCriterion')}}", {
                program_fetch: program_id_fetch,
                outcome_fetch: outcome_fetch
            },
            function(json) {
                json_length = (json.criterion.length);
                fullHTML = '';
                for (var i = 0; i < json_length; i++) {
                    fullHTML += '<option value="' + json.criterion[i].id + '">' + json.criterion[i].name + '</option>';
                }
                $('#select-criterion').html(fullHTML);
                $('#select-criterion').selectpicker('refresh');
                fetchCriterionForEditing()

            },
            'json'
        );
    }

    function deleteCriterion() {
        var id = $('#select-criterion').find(':selected').val()

        $.post(
            "{{ URL::action('CriteriaController@delete')}}", {
                id: id
            },
            function() {
                window.location.reload(true)
            }
        )
    }


    function fetchCriterionForEditing() {
        var id = $('#select-criterion').find(':selected').val();

        $.post(
            "{{ URL::action('CriteriaController@fetchCriterionWithTrashed') }}", {
                id: id
            },
            function(json) {

                if (!(json.activity_criterion.length)) {

                    $('#DeleteButton').prop('enabled', true);

                } else {
                    $('#DeleteButton').prop('disabled', true);
                }

                if (!(json.criteria.length)) {
                    name = ' ';
                    var subcriteria = '';
                    copyright = null;
                    notes = null;
                    $('#status').val(0);
                    maximum = 1;
                    $('#assoc_maximum_score').val(1);


                } else {
                    var name = json.criteria[0].name;
                    if (json.criteria[0].subcriteria) {
                        subcriteria = JSON.parse(json.criteria[0].subcriteria).join('\n');
                    } else {
                        subcriteria = "";
                    }
                    if (json.criteria[0].copyright) {
                        var copyright = json.criteria[0].copyright;
                    } else {
                        var copyright = ''
                    }
                    if (json.criteria[0].notes) notes = json.criteria[0].notes;
                    else notes = '';

                    // Display info
                    $('#criterion_name').val(name);
                    $('#criterion_subcriteria').text(subcriteria);
                    if (json.criteria[0].deleted_at)
                        $('#status').val(0);
                    else
                        $('#status').val(1);
                    $('#assoc_maximum_score').val(json.criteria[0].maximum_score);
                    var maximum = json.criteria[0].maximum_score;

                    // If copyright or notes aren't empty, load them

                }



                $('#criterion_copyright').text(copyright);


                $('#criterion_notes').text(notes);







                // Select associated outcome
                try {
                    assocOutcomeCounter= parseInt($("#assocOutcomeGroup").data('value'));
                    for (var i = assocOutcomeCounter - 1; i > 0; i--) {
                        deleteLast("assoc_outcomeForm" + i.toString() , "assocOutcomeGroup", "assoc_close" + i.toString() ,"assoc_objectiveGroup");
                    }
                } catch (err) {
                    var Notran = true;
                }

                if (json.outcomes.length) {
                    $('#assoc_outcome_0').val(json.outcomes[0].id);
                    $('#assoc_outcome_0').selectpicker('refresh');
                } else {
                    $('#assoc_outcome_0').val($('#assoc_outcomes_fetch').find(':selected').val());
                    $('#assoc_outcome_0').selectpicker('refresh');
                }



                for (var i = 1; i < json.outcomes.length; i++) {
                    addAssocOutcome();
                    $('#assoc_outcome_' + i.toString()).val(json.outcomes[i].id);
                    $('#assoc_outcome_' + i.toString()).selectpicker('refresh');

                }



                counterObj =$('#assoc_objectiveGroup').data('value');
                

                try {
                    for (var i = counterObj - 1; i > 0; i--) {
                        deleteObjective('assoc_objectiveForm' + i.toString(), 'assoc_closeObj' + i.toString(), 'assoc_objectiveGroup')
                    }
                } catch (err) {
                    var noEntro = true;
                }
                $('#assoc_objectiveGroup').data('value', 1);





                assocOutcomeCounter = 0;
                var i = 0;
                optionName = '<option value ="0">Nothing Selected</option>';
                for(outcome in json.outcomes_assoc){
                    optionName += '<optgroup label="' + json.outcomes_assoc[outcome][0].name + '">';
                    var objectiveForOutcome = json.objectives_assoc;
                    var objectives = objectiveForOutcome[outcome];
                    for (objective in objectives) {
                

                        var obj= objectives[objective];
                        var option = '<option value ="' + obj.id + '">' +obj.text + '</option>';
                        optionName += (option);
                    }
                    optionName += "</optgroup>";
                }


                $('#assoc_objective_0').html(optionName);
                $('#assoc_objective_0').selectpicker('refresh');
                



                try {
                    $('#assoc_objective_0').val(json.objectives[0].id);
                    $('#assoc_objective_0').selectpicker('refresh');
                } catch (err) {
                    if (!json.objectives.length) {
                        $('#assoc_objective_0').val(0);
                        $('#assoc_objective_0').selectpicker('refresh');
                    }
                 
                }

                for (var i = 1; i < json.objectives.length; i++) {
                    addAssocObjective();
                    $('#assoc_objective_' + i.toString()).val(json.objectives[i].id);
                    $('#assoc_objective_' + i.toString()).selectpicker('refresh');
                }
                $('assoc_objectiveGroup').data('value',json.objectives.length);






                // Select associated program
                var program_length = json.program.length;
                $('input[type=checkbox]').prop('checked', false);

                for (var i = 0; i < program_length; i++) {
                    $('#assoc_program_id_' + json.program[i].program_id).prop("checked", true);
                }


                // Select status





            },
            'json'
        );
    }
</script>@stop

@section('javascript')

// --------------------------------------------------------------------------
// Page load
// --------------------------------------------------------------------------

// Hide accordion panel contents by default
$('.panel-group .panel-body').hide();

$('#outcome-display').parent().hide();

fetchCriterionForEditing();
fetchObjectiveForSelect('outcomeGroup', 'objectiveGroup');
// setCriterionStatus();
fetchAllCriterion("select-program", "assoc_outcomes_fetch");



// --------------------------------------------------------------------------
// Functions
// --------------------------------------------------------------------------
$('#button-add-outcome').on('click', function(e) {
// Prevent the default action of the clicked item. In this case that is submit
e.preventDefault();


return false;
});
$('#button-add-objective-assoc').on('click', function(e) {
// Prevent the default action of the clicked item. In this case that is submit
e.preventDefault();


return false;
});
$('#button-add-outcome-assoc').on('click', function(e) {
// Prevent the default action of the clicked item. In this case that is submit
e.preventDefault();


return false;
});
$('#button-add-objective').on('click', function(e) {
// Prevent the default action of the clicked item. In this case that is submit
e.preventDefault();


return false;
});
// Fetch criterion info for editing


// --------------------------------------------------------------------------
// Events
// --------------------------------------------------------------------------

// When panel heading is clicked, toggle it
$('.panel-group .panel-heading').on('click', function()
{
$(this).next().stop().slideToggle();
})
$('.filterButton').on('click', function(e) {
    
        // Prevent the default action of the clicked item. In this case that is submit
    
        e.preventDefault();
    
        
    
        
    
        return false;
    
        });
//$('#outcome[0]').on('change', function(){
//fetchObjectiveForSelect(0);
//$('.selectpicker').selectpicker('refresh');
//})
// When list item is clicked, load corresponding info


// When list item is clicked, load corresponding info
$('.selectpicker').on('change', function()
{
//alert($(this).find(':selected').val());
$('.selectpicker').selectpicker('refresh');
});

@stop